﻿using System.Drawing;
using System.Windows.Forms;

namespace KnightTour
{
    public partial class ChessSquare : UserControl
    {
        public bool IsWhiteHome
        {
            get { return isWhiteHome; }
            set 
            {
                isWhiteHome = value;
                SetColor();
            }
        }

        public bool IsMarked
        {
            get { return isMarked; }
            set 
            {
                isMarked = value;
                SetColor();
            }
        }

        public bool ShowKnight
        {
            get { return pictureBox.Visible; }
            set { pictureBox.Visible = value; }
        }

        public ChessSquare()
        {
            InitializeComponent();

            IsWhiteHome = true;
        }

        private bool isWhiteHome = true;
        private bool isMarked = false;

        private void SetColor()
        {
            if (isMarked)
            {
                BackColor = Color.Salmon;
            }
            else
            {
                BackColor = isWhiteHome ? Color.Wheat : Color.DarkGoldenrod;
            }
            return;
        }
    }
}
