﻿using System;
using System.Windows.Forms;

namespace KnightTour
{
    public partial class Main : Form
    {
        public Main()
        {
            InitializeComponent();
        }

        private void Start()
        {
            if (!chessBoard.IsBusy)
            {
                int positionX = (int)rowNumericUpDown.Value - 1;
                int positionY = (int)colNumericUpDown.Value - 1;

                WarnsdorffAlgorithm solver = new WarnsdorffAlgorithm();
                int[][] solution = solver.Solve(positionX, positionY);

                if (solution == null)
                {
                    MessageBox.Show("برنامه قادر به حل مساله در این خانه خاص نمی‌باشد.",
                        "خطا", MessageBoxButtons.OK, MessageBoxIcon.Error,
                        MessageBoxDefaultButton.Button1, MessageBoxOptions.RtlReading);
                    return;
                }

                rowNumericUpDown.Enabled = false;
                colNumericUpDown.Enabled = false;
                startButton.Enabled = false;
                stopButton.Enabled = true;
                chessBoard.ShowSolutionAnimation(solution);
            }
            return;
        }

        private void Stop()
        {
            if (chessBoard.IsBusy)
            {
                chessBoard.StopSolutionAnimation();
            }
            return;
        }

        private void ShowAbout()
        {
            About aboutForm = new About();
            aboutForm.ShowDialog();
            return;
        }

        private void startButton_Click(object sender, EventArgs e)
        {
            Start();
            return;
        }

        private void stopButton_Click(object sender, EventArgs e)
        {
            Stop();
            return;
        }

        private void aboutButton_Click(object sender, EventArgs e)
        {
            ShowAbout();
            return;
        }

        private void chessBoard_AnimationDone(object sender, EventArgs e)
        {
            rowNumericUpDown.Enabled = true;
            colNumericUpDown.Enabled = true;
            startButton.Enabled = true;
            stopButton.Enabled = false;
            return;
        }
    }
}
